/* A Bison parser, made by GNU Bison 3.0.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "parser_yacc.y" /* yacc.c:339  */

/*
 *   Copyright (c) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007
 *   NOVELL (All rights reserved)
 *   Copyright (c) 2010-2012
 *   Canonical Ltd.
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of version 2 of the GNU General Public
 *   License published by the Free Software Foundation.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, contact Canonical, Ltd.
 */

#define YYERROR_VERBOSE 1
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <getopt.h>
#include <errno.h>
#include <fcntl.h>
#include <libintl.h>
#define _(s) gettext(s)

/* #define DEBUG */

#include "parser.h"
#include "mount.h"
#include "parser_include.h"
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <linux/capability.h>

#ifndef CAP_AUDIT_WRITE
#define CAP_AUDIT_WRITE 29
#endif
#ifndef CAP_AUDIT_CONTROL
#define CAP_AUDIT_CONTROL 30
#endif
#ifndef CAP_SETFCAP
#define CAP_SETFCAP	     31
#endif
#ifndef CAP_MAC_OVERRIDE
#define CAP_MAC_OVERRIDE     32
#endif

#define CIDR_32 htonl(0xffffffff)
#define CIDR_24 htonl(0xffffff00)
#define CIDR_16 htonl(0xffff0000)
#define CIDR_8  htonl(0xff000000)

/* undefine linux/capability.h CAP_TO_MASK */
#ifdef CAP_TO_MASK
#undef CAP_TO_MASK
#endif

#define CAP_TO_MASK(x) (1ull << (x))

int parser_token = 0;

struct cod_entry *do_file_rule(char *namespace, char *id, int mode,
			       char *link_id, char *nt);
struct mnt_entry *do_mnt_rule(struct cond_entry *src_conds, char *src,
			      struct cond_entry *dst_conds, char *dst,
			      int mode);
struct mnt_entry *do_pivot_rule(struct cond_entry *old, char *root,
				char *transition);

void add_local_entry(struct codomain *cod);


#line 147 "parser_yacc.c" /* yacc.c:339  */

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser_yacc.h".  */
#ifndef YY_YY_PARSER_YACC_H_INCLUDED
# define YY_YY_PARSER_YACC_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_ID = 258,
    TOK_CONDID = 259,
    TOK_CARET = 260,
    TOK_OPEN = 261,
    TOK_CLOSE = 262,
    TOK_MODE = 263,
    TOK_END_OF_RULE = 264,
    TOK_EQUALS = 265,
    TOK_ARROW = 266,
    TOK_ADD_ASSIGN = 267,
    TOK_LE = 268,
    TOK_SET_VAR = 269,
    TOK_BOOL_VAR = 270,
    TOK_VALUE = 271,
    TOK_IF = 272,
    TOK_ELSE = 273,
    TOK_NOT = 274,
    TOK_DEFINED = 275,
    TOK_CHANGE_PROFILE = 276,
    TOK_NETWORK = 277,
    TOK_HAT = 278,
    TOK_UNSAFE = 279,
    TOK_SAFE = 280,
    TOK_COLON = 281,
    TOK_LINK = 282,
    TOK_OWNER = 283,
    TOK_OTHER = 284,
    TOK_SUBSET = 285,
    TOK_AUDIT = 286,
    TOK_DENY = 287,
    TOK_PROFILE = 288,
    TOK_SET = 289,
    TOK_ALIAS = 290,
    TOK_PTRACE = 291,
    TOK_OPENPAREN = 292,
    TOK_CLOSEPAREN = 293,
    TOK_COMMA = 294,
    TOK_FILE = 295,
    TOK_MOUNT = 296,
    TOK_REMOUNT = 297,
    TOK_UMOUNT = 298,
    TOK_PIVOTROOT = 299,
    TOK_IN = 300,
    TOK_RLIMIT = 301,
    TOK_SOFT_RLIMIT = 302,
    TOK_RLIMIT_CPU = 303,
    TOK_RLIMIT_FSIZE = 304,
    TOK_RLIMIT_DATA = 305,
    TOK_RLIMIT_STACK = 306,
    TOK_RLIMIT_CORE = 307,
    TOK_RLIMIT_RSS = 308,
    TOK_RLIMIT_NOFILE = 309,
    TOK_RLIMIT_OFILE = 310,
    TOK_RLIMIT_AS = 311,
    TOK_RLIMIT_NPROC = 312,
    TOK_RLIMIT_MEMLOCK = 313,
    TOK_RLIMIT_LOCKS = 314,
    TOK_RLIMIT_SIGPENDING = 315,
    TOK_RLIMIT_MSGQUEUE = 316,
    TOK_RLIMIT_NICE = 317,
    TOK_RLIMIT_RTPRIO = 318,
    TOK_CAPABILITY = 319,
    TOK_FLAGS = 320
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 152 "parser_yacc.y" /* yacc.c:355  */

	char *id;
	char *flag_id;
	char *mode;
	struct aa_network_entry *network_entry;
	struct codomain *cod;
	struct cod_net_entry *net_entry;
	struct cod_entry *user_entry;
	struct mnt_entry *mnt_entry;

	struct flagval flags;
	int fmode;
	uint64_t cap;
	unsigned int allowed_protocol;
	char *set_var;
	char *bool_var;
	char *var_val;
	struct value_list *val_list;
	struct cond_entry *cond_entry;
	int boolean;
	struct named_transition transition;

#line 276 "parser_yacc.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_PARSER_YACC_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 291 "parser_yacc.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if (! defined __GNUC__ || __GNUC__ < 2 \
      || (__GNUC__ == 2 && __GNUC_MINOR__ < 5))
#  define __attribute__(Spec) /* empty */
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   215

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  66
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  43
/* YYNRULES -- Number of rules.  */
#define YYNRULES  104
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  194

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   320

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   220,   220,   223,   225,   231,   232,   233,   235,   236,
     238,   239,   241,   271,   288,   299,   309,   310,   311,   313,
     321,   345,   370,   390,   400,   411,   417,   418,   425,   430,
     452,   457,   489,   490,   491,   493,   494,   496,   497,   498,
     500,   513,   535,   557,   588,   626,   664,   674,   683,   693,
     701,   709,   718,   728,   734,   826,   838,   852,   866,   871,
     886,   896,   906,   907,   910,   915,   921,   928,   929,   930,
     932,   933,   934,   936,   937,   939,   944,   961,   972,   975,
     990,   999,  1009,  1018,  1027,  1042,  1055,  1066,  1080,  1090,
    1099,  1100,  1106,  1111,  1116,  1121,  1126,  1145,  1146,  1148,
    1156,  1167,  1179,  1188,  1189
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ID", "TOK_CONDID", "TOK_CARET",
  "TOK_OPEN", "TOK_CLOSE", "TOK_MODE", "TOK_END_OF_RULE", "TOK_EQUALS",
  "TOK_ARROW", "TOK_ADD_ASSIGN", "TOK_LE", "TOK_SET_VAR", "TOK_BOOL_VAR",
  "TOK_VALUE", "TOK_IF", "TOK_ELSE", "TOK_NOT", "TOK_DEFINED",
  "TOK_CHANGE_PROFILE", "TOK_NETWORK", "TOK_HAT", "TOK_UNSAFE", "TOK_SAFE",
  "TOK_COLON", "TOK_LINK", "TOK_OWNER", "TOK_OTHER", "TOK_SUBSET",
  "TOK_AUDIT", "TOK_DENY", "TOK_PROFILE", "TOK_SET", "TOK_ALIAS",
  "TOK_PTRACE", "TOK_OPENPAREN", "TOK_CLOSEPAREN", "TOK_COMMA", "TOK_FILE",
  "TOK_MOUNT", "TOK_REMOUNT", "TOK_UMOUNT", "TOK_PIVOTROOT", "TOK_IN",
  "TOK_RLIMIT", "TOK_SOFT_RLIMIT", "TOK_RLIMIT_CPU", "TOK_RLIMIT_FSIZE",
  "TOK_RLIMIT_DATA", "TOK_RLIMIT_STACK", "TOK_RLIMIT_CORE",
  "TOK_RLIMIT_RSS", "TOK_RLIMIT_NOFILE", "TOK_RLIMIT_OFILE",
  "TOK_RLIMIT_AS", "TOK_RLIMIT_NPROC", "TOK_RLIMIT_MEMLOCK",
  "TOK_RLIMIT_LOCKS", "TOK_RLIMIT_SIGPENDING", "TOK_RLIMIT_MSGQUEUE",
  "TOK_RLIMIT_NICE", "TOK_RLIMIT_RTPRIO", "TOK_CAPABILITY", "TOK_FLAGS",
  "$accept", "list", "profilelist", "opt_profile_flag", "opt_namespace",
  "opt_id", "profile_base", "profile", "local_profile", "hat", "preamble",
  "alias", "varassign", "valuelist", "flags", "opt_flags", "flagvals",
  "flagval", "opt_subset_flag", "opt_audit_flag", "opt_owner_flag",
  "rules", "cond_rule", "expr", "id_or_var", "opt_named_transition",
  "rule", "opt_unsafe", "opt_file", "frule", "file_rule", "file_rule_tail",
  "link_rule", "ptrace_rule", "network_rule", "cond", "opt_conds",
  "mnt_rule", "hat_start", "file_mode", "change_profile", "capability",
  "caps", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320
};
# endif

#define YYPACT_NINF -128

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-128)))

#define YYTABLE_NINF -27

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -128,     9,    88,  -128,   125,    44,    18,    23,  -128,  -128,
      46,    46,    56,    82,  -128,  -128,  -128,    72,  -128,  -128,
    -128,    90,    90,  -128,   136,   143,   144,  -128,   142,   103,
     145,  -128,  -128,  -128,  -128,     2,   146,   147,   115,  -128,
    -128,   138,    43,  -128,    13,  -128,  -128,    38,   148,  -128,
     144,   109,  -128,  -128,   -17,  -128,   144,  -128,  -128,  -128,
    -128,    38,   126,   151,    11,  -128,   155,   111,  -128,  -128,
      -9,  -128,  -128,  -128,  -128,  -128,     4,  -128,  -128,  -128,
    -128,  -128,  -128,  -128,  -128,   152,   157,   149,   118,  -128,
      77,  -128,  -128,  -128,   122,   122,   122,   122,   119,  -128,
      60,    19,   154,  -128,   120,  -128,  -128,  -128,    58,  -128,
     140,   153,   156,  -128,  -128,    -2,   127,  -128,   158,   159,
     160,  -128,  -128,    63,  -128,  -128,   161,   163,   167,  -128,
    -128,  -128,   102,  -128,   162,   170,   165,  -128,    51,   141,
    -128,  -128,  -128,  -128,    35,   166,  -128,   168,  -128,   150,
    -128,  -128,  -128,   169,  -128,    60,     1,   172,  -128,  -128,
      46,    46,   139,   105,  -128,  -128,   179,   180,   104,   105,
    -128,  -128,  -128,    14,    62,   175,   164,   176,   177,  -128,
     178,   160,    78,  -128,  -128,  -128,   105,  -128,  -128,  -128,
     182,  -128,  -128,  -128
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      16,     0,     3,     1,     0,     0,     0,     5,    17,    18,
       0,     0,     0,     0,    97,    98,     6,     8,     4,     7,
      23,    20,    21,    22,     0,     0,     0,    24,     0,     0,
      10,    13,    19,     9,    11,    25,     0,     0,     0,    27,
      40,     0,    35,    31,     0,    30,    12,     0,     0,    36,
       0,     0,    52,    51,    37,    53,     0,    48,    28,    29,
      59,     0,     0,     0,     0,    14,     0,     0,    38,    39,
      37,    90,    90,    90,    90,   103,    73,    45,    47,    50,
      15,    58,    60,    61,    40,     0,     0,     0,     0,    84,
      73,    44,    46,    49,    10,    10,    10,    10,     0,    40,
      32,     0,    74,    42,    70,    67,    68,    69,    35,   100,
       0,     0,     0,    85,    41,     0,     0,    91,     0,     0,
      64,   104,   102,    35,    34,    33,     0,     0,     0,    77,
      71,    72,     0,    78,    55,     0,     0,    86,     0,     0,
      92,    90,    94,    95,     0,     0,    43,     0,    82,     0,
      62,    99,    63,     0,    79,    32,     0,     0,    54,    87,
       0,     0,     0,     0,    65,    96,     0,     0,    64,     0,
      40,    57,   101,     0,     0,     0,     0,     0,     0,    80,
       0,    64,    35,    88,    89,    93,     0,    81,    83,    75,
       0,    56,    66,    76
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -128,  -128,  -128,  -128,  -128,    37,    74,  -128,  -128,  -128,
    -128,  -128,  -128,   -11,  -128,  -128,  -128,   171,    33,  -128,
     123,   -83,    36,   128,  -127,   -99,   106,  -128,  -128,  -128,
    -128,  -128,  -128,  -128,   124,  -128,   -70,   129,   188,    45,
    -128,   130,  -128
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     7,    17,    26,    35,    31,    18,    52,    53,
       2,     8,     9,    21,    37,    38,    44,    45,   126,    54,
      76,    42,    55,    63,   153,   145,   103,   132,   104,   154,
     105,   133,   106,   107,    77,   117,    94,    78,    56,   155,
      57,    79,    98
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      22,   108,    95,    96,    97,    67,    36,   170,   138,     3,
      99,    68,    69,    67,    85,    70,   123,   164,    47,    68,
      69,    13,   127,    -2,    71,    72,    73,    74,    14,    43,
      27,   100,    71,    72,    73,    74,   176,    86,   150,   -26,
     101,   179,   181,   139,   102,   128,    15,    75,    14,   152,
      46,    58,   183,    60,    12,    75,    16,    61,    62,   192,
      47,   163,    20,    14,    48,   134,    15,   159,    14,   180,
     146,   162,    23,   124,    49,    47,    50,    51,    27,    48,
      47,    15,   190,    14,    48,   191,    15,   182,   160,    49,
     125,    50,    51,    24,    49,    47,    50,    51,    25,    48,
     184,    15,     4,     5,   100,   150,    27,   150,   150,    49,
     151,    50,    51,   101,    88,   144,   152,   102,   152,   152,
      89,   112,   121,     6,    65,    34,   115,   113,   122,    33,
      80,   116,   118,   119,   120,    10,   140,    11,   141,    28,
      82,    83,   175,   115,   130,   131,    29,    30,    34,   173,
     174,    32,    41,    40,    43,    66,    39,    84,    87,    64,
     110,   109,   111,   129,   147,   137,   135,   142,   143,   136,
     149,   144,   148,   157,   158,   165,   167,   151,   161,   166,
     156,   172,   177,   178,   185,   187,   188,   189,   169,    81,
     186,   193,   171,    90,    91,    19,   114,     0,   168,    92,
      93,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    59
};

static const yytype_int16 yycheck[] =
{
      11,    84,    72,    73,    74,    22,     4,     6,    10,     0,
       6,    28,    29,    22,     3,    32,    99,   144,    17,    28,
      29,     3,     3,     0,    41,    42,    43,    44,     5,    16,
      16,    27,    41,    42,    43,    44,   163,    26,     3,    37,
      36,   168,   169,    45,    40,    26,    23,    64,     5,    14,
       7,    38,    38,    15,    10,    64,    33,    19,    20,   186,
      17,    26,    16,     5,    21,     7,    23,    16,     5,   168,
       7,   141,    16,    13,    31,    17,    33,    34,    16,    21,
      17,    23,   181,     5,    21,     7,    23,   170,    37,    31,
      30,    33,    34,    11,    31,    17,    33,    34,    26,    21,
      38,    23,    14,    15,    27,     3,    16,     3,     3,    31,
       8,    33,    34,    36,     3,    11,    14,    40,    14,    14,
       9,     3,     3,    35,    50,     3,     4,     9,     9,    26,
      56,    94,    95,    96,    97,    10,     9,    12,    11,     3,
      14,    15,     3,     4,    24,    25,     3,     3,     3,   160,
     161,     9,    37,     6,    16,    46,    10,     6,     3,    11,
       3,     9,    13,     9,     3,     9,    26,     9,     9,    16,
       3,    11,     9,     3,     9,     9,    26,     8,    37,    11,
      18,     9,     3,     3,     9,     9,     9,     9,   155,    61,
      26,     9,   156,    70,    70,     7,    90,    -1,   153,    70,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    44
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    67,    76,     0,    14,    15,    35,    68,    77,    78,
      10,    12,    10,     3,     5,    23,    33,    69,    73,   104,
      16,    79,    79,    16,    11,    26,    70,    16,     3,     3,
       3,    72,     9,    26,     3,    71,     4,    80,    81,    10,
       6,    37,    87,    16,    82,    83,     7,    17,    21,    31,
      33,    34,    74,    75,    85,    88,   104,   106,    38,    83,
      15,    19,    20,    89,    11,    72,    46,    22,    28,    29,
      32,    41,    42,    43,    44,    64,    86,   100,   103,   107,
      72,    89,    14,    15,     6,     3,    26,     3,     3,     9,
      86,   100,   103,   107,   102,   102,   102,   102,   108,     6,
      27,    36,    40,    92,    94,    96,    98,    99,    87,     9,
       3,    13,     3,     9,    92,     4,    71,   101,    71,    71,
      71,     3,     9,    87,    13,    30,    84,     3,    26,     9,
      24,    25,    93,    97,     7,    26,    16,     9,    10,    45,
       9,    11,     9,     9,    11,    91,     7,     3,     9,     3,
       3,     8,    14,    90,    95,   105,    18,     3,     9,    16,
      37,    37,   102,    26,    90,     9,    11,    26,   105,    84,
       6,    88,     9,    79,    79,     3,    90,     3,     3,    90,
      91,    90,    87,    38,    38,     9,    26,     9,     9,     9,
      91,     7,    90,     9
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    66,    67,    68,    68,    69,    69,    69,    70,    70,
      71,    71,    72,    73,    74,    75,    76,    76,    76,    77,
      78,    78,    78,    79,    79,    80,    81,    81,    80,    82,
      82,    83,    84,    84,    84,    85,    85,    86,    86,    86,
      87,    87,    87,    87,    87,    87,    87,    87,    87,    87,
      87,    87,    87,    87,    87,    88,    88,    88,    89,    89,
      89,    89,    90,    90,    91,    91,    91,    92,    92,    92,
      93,    93,    93,    94,    94,    95,    95,    96,    96,    97,
      97,    98,    99,    99,   100,   100,   100,   101,   101,   101,
     102,   102,   103,   103,   103,   103,   103,   104,   104,   105,
     106,   106,   107,   108,   108
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     2,     0,     1,     1,     0,     3,
       0,     1,     6,     3,     2,     2,     0,     2,     2,     5,
       3,     3,     3,     1,     2,     0,     0,     2,     4,     2,
       1,     1,     0,     1,     1,     0,     1,     0,     1,     1,
       0,     5,     4,     6,     4,     3,     4,     3,     2,     4,
       3,     2,     2,     2,     7,     5,     9,     7,     2,     1,
       2,     2,     1,     1,     0,     2,     5,     1,     1,     1,
       0,     1,     1,     0,     1,     4,     5,     2,     2,     2,
       4,     6,     3,     6,     2,     3,     4,     3,     5,     5,
       0,     2,     4,     7,     4,     4,     5,     1,     1,     1,
       4,     7,     3,     0,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 221 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ }
#line 1509 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 3:
#line 223 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ }
#line 1515 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 4:
#line 226 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("Matched: list profile\n");
		add_to_list((yyvsp[0].cod));
	}
#line 1524 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 5:
#line 231 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 1530 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 6:
#line 232 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 1536 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 7:
#line 233 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 2; }
#line 1542 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 8:
#line 235 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.id) = NULL; }
#line 1548 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 9:
#line 236 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[-1].id); }
#line 1554 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 10:
#line 238 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.id) = NULL; }
#line 1560 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 11:
#line 239 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 1566 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 12:
#line 242 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct codomain *cod = (yyvsp[-1].cod);

		if (!cod) {
			yyerror(_("Memory allocation error."));
		}

		cod->name = (yyvsp[-5].id);
		cod->attachment = (yyvsp[-4].id);
		if ((yyvsp[-4].id) && (yyvsp[-4].id)[0] != '/')
			/* we don't support variables as part of the profile
			 * name or attachment atm
			 */
			yyerror(_("Profile attachment must begin with a '/'."));
		cod->flags = (yyvsp[-3].flags);
		if (force_complain)
			cod->flags.complain = 1;

		post_process_file_entries(cod);
		post_process_mnt_entries(cod);
		PDEBUG("%s: flags='%s%s'\n",
		       (yyvsp[-4].id),
		       cod->flags.complain ? "complain, " : "",
		       cod->flags.audit ? "audit" : "");

		(yyval.cod) = cod;

	}
#line 1599 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 13:
#line 272 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct codomain *cod = (yyvsp[0].cod);
		if ((yyvsp[-1].id))
			PDEBUG("Matched: %s://%s { ... }\n", (yyvsp[-1].id), (yyvsp[0].cod)->name);
		else
			PDEBUG("Matched: %s { ... }\n", (yyvsp[0].cod)->name);

		if ((yyvsp[0].cod)->name[0] != '/' && !((yyvsp[-2].boolean) || (yyvsp[-1].id)))
			yyerror(_("Profile names must begin with a '/', namespace or keyword 'profile' or 'hat'."));

		cod->namespace = (yyvsp[-1].id);
		if ((yyvsp[-2].boolean) == 2)
			cod->flags.hat = 1;
		(yyval.cod) = cod;
	}
#line 1619 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 14:
#line 289 "parser_yacc.y" /* yacc.c:1646  */
    {

		struct codomain *cod = (yyvsp[0].cod);

		if ((yyvsp[0].cod))
			PDEBUG("Matched: local profile %s { ... }\n", cod->name);
		cod->local = 1;
		(yyval.cod) = cod;
	}
#line 1633 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 15:
#line 300 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct codomain *cod = (yyvsp[0].cod);
		if ((yyvsp[0].cod))
			PDEBUG("Matched: hat %s { ... }\n", cod->name);

		cod->flags.hat = 1;
		(yyval.cod) = cod;
	}
#line 1646 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 16:
#line 309 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ }
#line 1652 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 17:
#line 310 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ }
#line 1658 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 18:
#line 311 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ }
#line 1664 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 19:
#line 314 "parser_yacc.y" /* yacc.c:1646  */
    {
		if (!new_alias((yyvsp[-3].id), (yyvsp[-1].id)))
			yyerror(_("Failed to create alias %s -> %s\n"), (yyvsp[-3].id), (yyvsp[-1].id));
		free((yyvsp[-3].id));
		free((yyvsp[-1].id));
	}
#line 1675 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 20:
#line 322 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct value_list *list = (yyvsp[0].val_list);
		char *var_name = process_var((yyvsp[-2].set_var));
		int err;
		if (!list || !list->value)
			yyerror("Assert: valuelist returned NULL");
		PDEBUG("Matched: set assignment for (%s)\n", (yyvsp[-2].set_var));
		err = new_set_var(var_name, list->value);
		if (err) {
			yyerror("variable %s was previously declared", (yyvsp[-2].set_var));
			/* FIXME: it'd be handy to report the previous location */
		}
		for (list = list->next; list; list = list->next) {
			err = add_set_value(var_name, list->value);
			if (err)
				yyerror("Error adding %s to set var %s",
					list->value, (yyvsp[-2].set_var));
		}
		free_value_list((yyvsp[0].val_list));
		free(var_name);
		free((yyvsp[-2].set_var));
	}
#line 1702 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 21:
#line 346 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct value_list *list = (yyvsp[0].val_list);
		char *var_name = process_var((yyvsp[-2].set_var));
		int err;
		if (!list || !list->value)
			yyerror("Assert: valuelist returned NULL");
		PDEBUG("Matched: additive assignment for (%s)\n", (yyvsp[-2].set_var));
		/* do the first one outside the loop, subsequent
		 * failures are indicative of symtab failures */
		err = add_set_value(var_name, list->value);
		if (err) {
			yyerror("variable %s was not previously declared, but is being assigned additional values", (yyvsp[-2].set_var));
		}
		for (list = list->next; list; list = list->next) {
			err = add_set_value(var_name, list->value);
			if (err)
				yyerror("Error adding %s to set var %s",
					list->value, (yyvsp[-2].set_var));
		}
		free_value_list((yyvsp[0].val_list));
		free(var_name);
		free((yyvsp[-2].set_var));
	}
#line 1730 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 22:
#line 371 "parser_yacc.y" /* yacc.c:1646  */
    {
		int boolean, err;
		char *var_name = process_var((yyvsp[-2].bool_var));
		PDEBUG("Matched: boolean assignment (%s) to %s\n", (yyvsp[-2].bool_var), (yyvsp[0].var_val));
		boolean = str_to_boolean((yyvsp[0].var_val));
		if (boolean == -1) {
			yyerror("Invalid boolean assignment for (%s): %s is not true or false",
				(yyvsp[-2].bool_var), (yyvsp[0].var_val));
		}
		err = add_boolean_var(var_name, boolean);
		if (err) {
			yyerror("variable %s was previously declared", (yyvsp[-2].bool_var));
			/* FIXME: it'd be handy to report the previous location */
		}
		free(var_name);
		free((yyvsp[-2].bool_var));
		free((yyvsp[0].var_val));
	}
#line 1753 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 23:
#line 391 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct value_list *val = new_value_list((yyvsp[0].var_val));
		if (!val)
			yyerror(_("Memory allocation error."));
		PDEBUG("Matched: value (%s)\n", (yyvsp[0].var_val));

		(yyval.val_list) = val;
	}
#line 1766 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 24:
#line 401 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct value_list *val = new_value_list((yyvsp[0].var_val));
		if (!val)
			yyerror(_("Memory allocation error."));
		PDEBUG("Matched: value list\n");

		list_append((yyvsp[-1].val_list), val);
		(yyval.val_list) = (yyvsp[-1].val_list);
	}
#line 1780 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 25:
#line 411 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */
	struct flagval fv = { 0, 0, 0, 0 };

		(yyval.flags) = fv;
	}
#line 1790 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 26:
#line 417 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 1796 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 27:
#line 419 "parser_yacc.y" /* yacc.c:1646  */
    {
		if (strcmp((yyvsp[-1].id), "flags") != 0)
			yyerror("expected flags= got %s=", (yyvsp[-1].id));
		(yyval.boolean) = 1;
	}
#line 1806 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 28:
#line 426 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.flags) = (yyvsp[-1].flags);
	}
#line 1814 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 29:
#line 431 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyvsp[-1].flags).complain = (yyvsp[-1].flags).complain || (yyvsp[0].flags).complain;
		(yyvsp[-1].flags).audit = (yyvsp[-1].flags).audit || (yyvsp[0].flags).audit;
		(yyvsp[-1].flags).path = (yyvsp[-1].flags).path | (yyvsp[0].flags).path;
		if (((yyvsp[-1].flags).path & (PATH_CHROOT_REL | PATH_NS_REL)) ==
		    (PATH_CHROOT_REL | PATH_NS_REL))
			yyerror(_("Profile flag chroot_relative conflicts with namespace_relative"));

		if (((yyvsp[-1].flags).path & (PATH_MEDIATE_DELETED | PATH_DELEGATE_DELETED)) ==
		    (PATH_MEDIATE_DELETED | PATH_DELEGATE_DELETED))
			yyerror(_("Profile flag mediate_deleted conflicts with delegate_deleted"));
		if (((yyvsp[-1].flags).path & (PATH_ATTACH | PATH_NO_ATTACH)) ==
		    (PATH_ATTACH | PATH_NO_ATTACH))
			yyerror(_("Profile flag attach_disconnected conflicts with no_attach_disconnected"));
		if (((yyvsp[-1].flags).path & (PATH_CHROOT_NSATTACH | PATH_CHROOT_NO_ATTACH)) ==
		    (PATH_CHROOT_NSATTACH | PATH_CHROOT_NO_ATTACH))
			yyerror(_("Profile flag chroot_attach conflicts with chroot_no_attach"));

		(yyval.flags) = (yyvsp[-1].flags);
	}
#line 1839 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 30:
#line 453 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.flags) = (yyvsp[0].flags);
	}
#line 1847 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 31:
#line 458 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct flagval fv = { 0, 0, 0, 0 };
		if (strcmp((yyvsp[0].var_val), "debug") == 0) {
			yyerror(_("Profile flag 'debug' is no longer valid."));
		} else if (strcmp((yyvsp[0].var_val), "complain") == 0) {
			fv.complain = 1;
		} else if (strcmp((yyvsp[0].var_val), "audit") == 0) {
			fv.audit = 1;
		} else if (strcmp((yyvsp[0].var_val), "chroot_relative") == 0) {
			fv.path |= PATH_CHROOT_REL;
		} else if (strcmp((yyvsp[0].var_val), "namespace_relative") == 0) {
			fv.path |= PATH_NS_REL;
		} else if (strcmp((yyvsp[0].var_val), "mediate_deleted") == 0) {
			fv.path |= PATH_MEDIATE_DELETED;
		} else if (strcmp((yyvsp[0].var_val), "delegate_deleted") == 0) {
			fv.path |= PATH_DELEGATE_DELETED;
		} else if (strcmp((yyvsp[0].var_val), "attach_disconnected") == 0) {
			fv.path |= PATH_ATTACH;
		} else if (strcmp((yyvsp[0].var_val), "no_attach_disconnected") == 0) {
			fv.path |= PATH_NO_ATTACH;
		} else if (strcmp((yyvsp[0].var_val), "chroot_attach") == 0) {
			fv.path |= PATH_CHROOT_NSATTACH;
		} else if (strcmp((yyvsp[0].var_val), "chroot_no_attach") == 0) {
			fv.path |= PATH_CHROOT_NO_ATTACH;
		} else {
			yyerror(_("Invalid profile flag: %s."), (yyvsp[0].var_val));
		}
		free((yyvsp[0].var_val));
		(yyval.flags) = fv;
	}
#line 1882 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 32:
#line 489 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 1888 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 33:
#line 490 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 1894 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 34:
#line 491 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 1900 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 35:
#line 493 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 1906 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 36:
#line 494 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 1912 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 37:
#line 496 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 1918 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 38:
#line 497 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 1924 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 39:
#line 498 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 2; }
#line 1930 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 40:
#line 500 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ 
		struct codomain *cod = NULL;
		cod = (struct codomain *) calloc(1, sizeof(struct codomain));
		if (!cod) {
			yyerror(_("Memory allocation error."));
		}

		(yyval.cod) = cod;
	}
#line 1944 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 41:
#line 514 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("matched: rules rule\n");
		PDEBUG("rules rule: (%s)\n", (yyvsp[0].user_entry)->name);
		if (!(yyvsp[0].user_entry))
			yyerror(_("Assert: `rule' returned NULL."));
		(yyvsp[0].user_entry)->deny = 1;
		if (((yyvsp[0].user_entry)->mode & AA_EXEC_BITS) && ((yyvsp[0].user_entry)->mode & ALL_AA_EXEC_TYPE))
			yyerror(_("Invalid mode, in deny rules 'x' must not be preceded by exec qualifier 'i', 'p', or 'u'"));

		if ((yyvsp[-1].boolean) == 1)
			(yyvsp[0].user_entry)->mode &= (AA_USER_PERMS | AA_SHARED_PERMS | AA_USER_PTRACE);
		else if ((yyvsp[-1].boolean) == 2)
			(yyvsp[0].user_entry)->mode &= (AA_OTHER_PERMS | AA_SHARED_PERMS | AA_OTHER_PTRACE);
		/* only set audit ctl quieting if the rule is not audited */
		if (!(yyvsp[-3].boolean))
			(yyvsp[0].user_entry)->audit = (yyvsp[0].user_entry)->mode & ~ALL_AA_EXEC_TYPE;

		add_entry_to_policy((yyvsp[-4].cod), (yyvsp[0].user_entry));
		(yyval.cod) = (yyvsp[-4].cod);
	}
#line 1969 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 42:
#line 536 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("matched: rules rule\n");
		PDEBUG("rules rule: (%s)\n", (yyvsp[0].user_entry)->name);
		if (!(yyvsp[0].user_entry))
			yyerror(_("Assert: `rule' returned NULL."));
		if (((yyvsp[0].user_entry)->mode & AA_EXEC_BITS) &&
		    !((yyvsp[0].user_entry)->mode & ALL_AA_EXEC_TYPE) &&
		    !((yyvsp[0].user_entry)->nt_name))
			yyerror(_("Invalid mode, 'x' must be preceded by exec qualifier 'i', 'p', 'c', or 'u'"));

		if ((yyvsp[-1].boolean) == 1)
			(yyvsp[0].user_entry)->mode &= (AA_USER_PERMS | AA_SHARED_PERMS | AA_USER_PTRACE);
		else if ((yyvsp[-1].boolean) == 2)
			(yyvsp[0].user_entry)->mode &= (AA_OTHER_PERMS | AA_SHARED_PERMS | AA_OTHER_PTRACE);
		if ((yyvsp[-2].boolean))
			(yyvsp[0].user_entry)->audit = (yyvsp[0].user_entry)->mode & ~ALL_AA_EXEC_TYPE;

		add_entry_to_policy((yyvsp[-3].cod), (yyvsp[0].user_entry));
		(yyval.cod) = (yyvsp[-3].cod);
	}
#line 1994 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 43:
#line 558 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cod_entry *entry, *tmp;
		PDEBUG("matched: audit block\n");
		list_for_each_safe((yyvsp[-1].cod)->entries, entry, tmp) {
			entry->next = NULL;
			if (entry->mode & AA_EXEC_BITS) {
				if (entry->deny &&
				    (entry->mode & ALL_AA_EXEC_TYPE))
					yyerror(_("Invalid mode, in deny rules 'x' must not be preceded by exec qualifier 'i', 'p', or 'u'"));
				else if (!entry->deny &&
					 !(entry->mode & ALL_AA_EXEC_TYPE))
					yyerror(_("Invalid mode, 'x' must be preceded by exec qualifier 'i', 'p', or 'u'"));
			}
			if ((yyvsp[-3].boolean) == 1)
 				entry->mode &= (AA_USER_PERMS | AA_SHARED_PERMS | AA_USER_PTRACE);
			else if ((yyvsp[-3].boolean) == 2)
				entry->mode &= (AA_OTHER_PERMS | AA_SHARED_PERMS | AA_OTHER_PTRACE);

			if ((yyvsp[-4].boolean) && !entry->deny)
				entry->audit = entry->mode & ~ALL_AA_EXEC_TYPE;
			else if (!(yyvsp[-4].boolean) && entry->deny)
				 entry->audit = entry->mode & ~ALL_AA_EXEC_TYPE;
			add_entry_to_policy((yyvsp[-5].cod), entry);
		}
		(yyvsp[-1].cod)->entries = NULL;
		// fix me transfer rules and free sub codomain
		free_policy((yyvsp[-1].cod));
		(yyval.cod) = (yyvsp[-5].cod);
	}
#line 2028 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 44:
#line 589 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct aa_network_entry *entry, *tmp;

		PDEBUG("Matched: network rule\n");
		if (!(yyvsp[0].network_entry))
			yyerror(_("Assert: `network_rule' return invalid protocol."));
		if (!(yyvsp[-3].cod)->network_allowed) {
			(yyvsp[-3].cod)->network_allowed = calloc(get_af_max(),
						     sizeof(unsigned int));
			(yyvsp[-3].cod)->audit_network = calloc(get_af_max(),
						   sizeof(unsigned int));
			(yyvsp[-3].cod)->deny_network = calloc(get_af_max(),
						     sizeof(unsigned int));
			(yyvsp[-3].cod)->quiet_network = calloc(get_af_max(),
						     sizeof(unsigned int));
			if (!(yyvsp[-3].cod)->network_allowed || !(yyvsp[-3].cod)->audit_network ||
			    !(yyvsp[-3].cod)->deny_network || !(yyvsp[-3].cod)->quiet_network)
				yyerror(_("Memory allocation error."));
		}
		list_for_each_safe((yyvsp[0].network_entry), entry, tmp) {
			if (entry->type > SOCK_PACKET) {
				/* setting mask instead of a bit */
				(yyvsp[-3].cod)->deny_network[entry->family] |= entry->type;
				if (!(yyvsp[-2].boolean))
					(yyvsp[-3].cod)->quiet_network[entry->family] |= entry->type;

			} else {
				(yyvsp[-3].cod)->deny_network[entry->family] |= 1 << entry->type;
				if (!(yyvsp[-2].boolean))
					(yyvsp[-3].cod)->quiet_network[entry->family] |= 1 << entry->type;
			}
			free(entry);
		}

		(yyval.cod) = (yyvsp[-3].cod);
	}
#line 2069 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 45:
#line 627 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct aa_network_entry *entry, *tmp;

		PDEBUG("Matched: network rule\n");
		if (!(yyvsp[0].network_entry))
			yyerror(_("Assert: `network_rule' return invalid protocol."));
		if (!(yyvsp[-2].cod)->network_allowed) {
			(yyvsp[-2].cod)->network_allowed = calloc(get_af_max(),
						     sizeof(unsigned int));
			(yyvsp[-2].cod)->audit_network = calloc(get_af_max(),
						   sizeof(unsigned int));
			(yyvsp[-2].cod)->deny_network = calloc(get_af_max(),
						     sizeof(unsigned int));
			(yyvsp[-2].cod)->quiet_network = calloc(get_af_max(),
						     sizeof(unsigned int));
			if (!(yyvsp[-2].cod)->network_allowed || !(yyvsp[-2].cod)->audit_network ||
			    !(yyvsp[-2].cod)->deny_network || !(yyvsp[-2].cod)->quiet_network)
				yyerror(_("Memory allocation error."));
		}
		list_for_each_safe((yyvsp[0].network_entry), entry, tmp) {
			if (entry->type > SOCK_PACKET) {
				/* setting mask instead of a bit */
				(yyvsp[-2].cod)->network_allowed[entry->family] |= entry->type;
				if ((yyvsp[-1].boolean))
					(yyvsp[-2].cod)->audit_network[entry->family] |= entry->type;

			} else {
				(yyvsp[-2].cod)->network_allowed[entry->family] |= 1 << entry->type;
				if ((yyvsp[-1].boolean))
					(yyvsp[-2].cod)->audit_network[entry->family] |= 1 << entry->type;
			}
			free(entry);
		}

		(yyval.cod) = (yyvsp[-2].cod);
	}
#line 2110 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 46:
#line 665 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyvsp[0].mnt_entry)->deny = (yyvsp[0].mnt_entry)->allow;
		if ((yyvsp[-2].boolean))
			(yyvsp[0].mnt_entry)->audit = (yyvsp[0].mnt_entry)->allow;
		(yyvsp[0].mnt_entry)->next = (yyvsp[-3].cod)->mnt_ents;
		(yyvsp[-3].cod)->mnt_ents = (yyvsp[0].mnt_entry);
		(yyval.cod) = (yyvsp[-3].cod);
	}
#line 2123 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 47:
#line 675 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].boolean))
			(yyvsp[0].mnt_entry)->audit = (yyvsp[0].mnt_entry)->allow;
		(yyvsp[0].mnt_entry)->next = (yyvsp[-2].cod)->mnt_ents;
		(yyvsp[-2].cod)->mnt_ents = (yyvsp[0].mnt_entry);
		(yyval.cod) = (yyvsp[-2].cod);
	}
#line 2135 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 48:
#line 684 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("matched: rules change_profile\n");
		PDEBUG("rules change_profile: (%s)\n", (yyvsp[0].user_entry)->name);
		if (!(yyvsp[0].user_entry))
			yyerror(_("Assert: `change_profile' returned NULL."));
		add_entry_to_policy((yyvsp[-1].cod), (yyvsp[0].user_entry));
		(yyval.cod) = (yyvsp[-1].cod);
	}
#line 2148 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 49:
#line 694 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyvsp[-3].cod)->deny_caps |= (yyvsp[0].cap);
		if (!(yyvsp[-2].boolean))
			(yyvsp[-3].cod)->quiet_caps |= (yyvsp[0].cap);
		(yyval.cod) = (yyvsp[-3].cod);
	}
#line 2159 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 50:
#line 702 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyvsp[-2].cod)->capabilities |= (yyvsp[0].cap);
		if ((yyvsp[-1].boolean))
			(yyvsp[-2].cod)->audit_caps |= (yyvsp[0].cap);
		(yyval.cod) = (yyvsp[-2].cod);
	}
#line 2170 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 51:
#line 710 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("Matched: hat rule\n");
		if (!(yyvsp[0].cod))
			yyerror(_("Assert: 'hat rule' returned NULL."));
		add_hat_to_policy((yyvsp[-1].cod), (yyvsp[0].cod));
		(yyval.cod) = (yyvsp[-1].cod);
	}
#line 2182 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 52:
#line 719 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("Matched: hat rule\n");
		if (!(yyvsp[0].cod))
			yyerror(_("Assert: 'local_profile rule' returned NULL."));
		add_hat_to_policy((yyvsp[-1].cod), (yyvsp[0].cod));
		add_local_entry((yyvsp[0].cod));
		(yyval.cod) = (yyvsp[-1].cod);
	}
#line 2195 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 53:
#line 729 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("Matched: conditional rules\n");
		(yyval.cod) = merge_policy((yyvsp[-1].cod), (yyvsp[0].cod));
	}
#line 2204 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 54:
#line 735 "parser_yacc.y" /* yacc.c:1646  */
    {
		rlim_t value = RLIM_INFINITY;
		long long tmp;
		char *end;

		int limit = get_rlimit((yyvsp[-3].id));
		if (limit == -1)
			yyerror("INVALID RLIMIT '%s'\n", (yyvsp[-3].id));

		if (strcmp((yyvsp[-1].var_val), "infinity") == 0) {
			value = RLIM_INFINITY;
		} else {
			const char *seconds = "seconds";
			const char *minutes = "minutes";
			const char *hours = "hours";
			const char *days = "days";
			const char *kb = "KB";
			const char *mb = "MB";
			const char *gb = "GB";

			tmp = strtoll((yyvsp[-1].var_val), &end, 0);
			switch (limit) {
			case RLIMIT_CPU:
				if (!end || (yyvsp[-1].var_val) == end || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s\n", (yyvsp[-3].id), (yyvsp[-1].var_val));
				if (*end == '\0' ||
				    strstr(seconds, end) == seconds) {
					value = tmp;
				} else if (strstr(minutes, end) == minutes) {
					value = tmp * 60;
				} else if (strstr(hours, end) == hours) {
					value = tmp * 60 * 60;
				} else if (strstr(days, end) == days) {
					value = tmp * 60 * 60 * 24;
				} else {
					yyerror("RLIMIT '%s' invalid value %s\n", (yyvsp[-3].id), (yyvsp[-1].var_val));
				}
				break;
			case RLIMIT_NOFILE:
			case RLIMIT_NPROC:
			case RLIMIT_LOCKS:
			case RLIMIT_SIGPENDING:
#ifdef RLIMIT_RTPRIO
			case RLIMIT_RTPRIO:
				if (!end || (yyvsp[-1].var_val) == end || *end != '\0' || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s\n", (yyvsp[-3].id), (yyvsp[-1].var_val));
				value = tmp;
				break;
#endif
#ifdef RLIMIT_NICE
			case RLIMIT_NICE:
				if (!end || (yyvsp[-1].var_val) == end || *end != '\0')
					yyerror("RLIMIT '%s' invalid value %s\n", (yyvsp[-3].id), (yyvsp[-1].var_val));
				if (tmp < -20 || tmp > 19)
					yyerror("RLIMIT '%s' out of range (-20 .. 19) %d\n", (yyvsp[-3].id), tmp);
				value = tmp + 20;
				break;
#endif
			case RLIMIT_FSIZE:
			case RLIMIT_DATA:
			case RLIMIT_STACK:
			case RLIMIT_CORE:
			case RLIMIT_RSS:
			case RLIMIT_AS:
			case RLIMIT_MEMLOCK:
			case RLIMIT_MSGQUEUE:
				if ((yyvsp[-1].var_val) == end || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s\n", (yyvsp[-3].id), (yyvsp[-1].var_val));
				if (strstr(kb, end) == kb) {
					tmp *= 1024;
				} else if (strstr(mb, end) == mb) {
					tmp *= 1024*1024;
				} else if (strstr(gb, end) == gb) {
					tmp *= 1024*1024*1024;
				} else if (*end != '\0') {
					yyerror("RLIMIT '%s' invalid value %s\n", (yyvsp[-3].id), (yyvsp[-1].var_val));
				}
				value = tmp;
				break;
			default:
				yyerror("Unknown RLIMIT %d\n", (yyvsp[-3].id));
			}
		}
		(yyvsp[-6].cod)->rlimits.specified |= 1 << limit;
		(yyvsp[-6].cod)->rlimits.limits[limit] = value;
		free((yyvsp[-3].id));
		free((yyvsp[-1].var_val));
		(yyval.cod) = (yyvsp[-6].cod);
	}
#line 2298 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 55:
#line 827 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct codomain *ret = NULL;
		PDEBUG("Matched: found conditional rules\n");
		if ((yyvsp[-3].boolean)) {
			ret = (yyvsp[-1].cod);
		} else {
			free_policy((yyvsp[-1].cod));
		}
		(yyval.cod) = ret;
	}
#line 2313 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 56:
#line 839 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct codomain *ret = NULL;
		PDEBUG("Matched: found conditional else rules\n");
		if ((yyvsp[-7].boolean)) {
			ret = (yyvsp[-5].cod);
			free_policy((yyvsp[-1].cod));
		} else {
			ret = (yyvsp[-1].cod);
			free_policy((yyvsp[-5].cod));
		}
		(yyval.cod) = ret;
	}
#line 2330 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 57:
#line 853 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct codomain *ret = NULL;
		PDEBUG("Matched: found conditional else-if rules\n");
		if ((yyvsp[-5].boolean)) {
			ret = (yyvsp[-3].cod);
			free_policy((yyvsp[0].cod));
		} else {
			ret = (yyvsp[0].cod);
			free_policy((yyvsp[-3].cod));
		}
		(yyval.cod) = ret;
	}
#line 2347 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 58:
#line 867 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.boolean) = !(yyvsp[0].boolean);
	}
#line 2355 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 59:
#line 872 "parser_yacc.y" /* yacc.c:1646  */
    {
		char *var_name = process_var((yyvsp[0].bool_var));
		int boolean  = get_boolean_var(var_name);
		PDEBUG("Matched: boolean expr %s value: %d\n", (yyvsp[0].bool_var), boolean);
		if (boolean < 0) {
			/* FIXME check for set var */
			yyerror(_("Unset boolean variable %s used in if-expression"),
				(yyvsp[0].bool_var));
		}
		(yyval.boolean) = boolean;
		free(var_name);
		free((yyvsp[0].bool_var));
	}
#line 2373 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 60:
#line 887 "parser_yacc.y" /* yacc.c:1646  */
    {
		char *var_name = process_var((yyvsp[0].set_var));
		void *set_value = get_set_var(var_name);
		PDEBUG("Matched: defined set expr %s value %lx\n", (yyvsp[0].set_var), (long) set_value);
		(yyval.boolean) = !! (long) set_value;
		free(var_name);
		free((yyvsp[0].set_var));
	}
#line 2386 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 61:
#line 897 "parser_yacc.y" /* yacc.c:1646  */
    {
		char *var_name = process_var((yyvsp[0].bool_var));
		int boolean = get_boolean_var(var_name);
		PDEBUG("Matched: defined set expr %s value %d\n", (yyvsp[0].bool_var), boolean);
		(yyval.boolean) = (boolean != -1);
		free(var_name);
		free((yyvsp[0].bool_var));
	}
#line 2399 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 62:
#line 906 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 2405 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 63:
#line 907 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].set_var); }
#line 2411 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 64:
#line 910 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */
		(yyval.transition).present = 0;
		(yyval.transition).namespace = NULL;
		(yyval.transition).name = NULL;
	}
#line 2421 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 65:
#line 916 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.transition).present = 1;
		(yyval.transition).namespace = NULL;
		(yyval.transition).name = (yyvsp[0].id);
	}
#line 2431 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 66:
#line 922 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.transition).present = 1;
		(yyval.transition).namespace = (yyvsp[-2].id);
		(yyval.transition).name = (yyvsp[0].id);
	}
#line 2441 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 67:
#line 928 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.user_entry) = (yyvsp[0].user_entry); }
#line 2447 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 68:
#line 929 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.user_entry) = (yyvsp[0].user_entry); }
#line 2453 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 69:
#line 930 "parser_yacc.y" /* yacc.c:1646  */
    {(yyval.user_entry) = (yyvsp[0].user_entry); }
#line 2459 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 70:
#line 932 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 2465 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 71:
#line 933 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 2471 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 72:
#line 934 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 2; }
#line 2477 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 73:
#line 936 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 2483 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 74:
#line 937 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 2489 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 75:
#line 940 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.user_entry) = do_file_rule((yyvsp[-1].transition).namespace, (yyvsp[-3].id), (yyvsp[-2].fmode), NULL, (yyvsp[-1].transition).name);
	}
#line 2497 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 76:
#line 945 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-3].boolean) && ((yyvsp[-4].fmode) & ~AA_LINK_BITS))
			yyerror(_("subset can only be used with link rules."));
		if ((yyvsp[-1].transition).present && ((yyvsp[-4].fmode) & AA_LINK_BITS) && ((yyvsp[-4].fmode) & AA_EXEC_BITS))
			yyerror(_("link and exec perms conflict on a file rule using ->"));
		if ((yyvsp[-1].transition).present && (yyvsp[-1].transition).namespace && ((yyvsp[-4].fmode) & AA_LINK_BITS))
			yyerror(_("link perms are not allowed on a named profile transition.\n"));
		if (((yyvsp[-4].fmode) & AA_LINK_BITS)) {
			(yyval.user_entry) = do_file_rule(NULL, (yyvsp[-2].id), (yyvsp[-4].fmode), (yyvsp[-1].transition).name, NULL);
			(yyval.user_entry)->subset = (yyvsp[-3].boolean);

		} else {
			(yyval.user_entry) = do_file_rule((yyvsp[-1].transition).namespace, (yyvsp[-2].id), (yyvsp[-4].fmode), NULL, (yyvsp[-1].transition).name);
		}
 	}
#line 2517 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 77:
#line 962 "parser_yacc.y" /* yacc.c:1646  */
    {
		char *path = strdup("/{**,}");
		int perms = ((AA_BASE_PERMS & ~AA_EXEC_TYPE) |
			     (AA_EXEC_INHERIT | AA_MAY_EXEC));
		/* duplicate to other permission set */
		perms |= perms << AA_OTHER_SHIFT;
		if (!path)
			yyerror(_("Memory allocation error."));
		(yyval.user_entry) = do_file_rule(NULL, path, perms, NULL, NULL);
	}
#line 2532 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 78:
#line 972 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.user_entry) = (yyvsp[0].user_entry); }
#line 2538 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 79:
#line 976 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].boolean)) {
			if (!((yyvsp[0].user_entry)->mode & AA_EXEC_BITS))
				yyerror(_("unsafe rule missing exec permissions"));
			if ((yyvsp[-1].boolean) == 1) {
				(yyvsp[0].user_entry)->mode |= (((yyvsp[0].user_entry)->mode & AA_EXEC_BITS) << 8) &
					 ALL_AA_EXEC_UNSAFE;
			}
			else if ((yyvsp[-1].boolean) == 2)
				(yyvsp[0].user_entry)->mode &= ~ALL_AA_EXEC_UNSAFE;
		}
		(yyval.user_entry) = (yyvsp[0].user_entry);
	}
#line 2556 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 80:
#line 991 "parser_yacc.y" /* yacc.c:1646  */
    {
		/* Oopsie, we appear to be missing an EOL marker. If we
		 * were *smart*, we could work around it. Since we're
		 * obviously not smart, we'll just punt with a more
		 * sensible error. */
		yyerror(_("missing an end of line character? (entry: %s)"), (yyvsp[-2].id));
	}
#line 2568 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1000 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cod_entry *entry;
		PDEBUG("Matched: link tok_id (%s) -> (%s)\n", (yyvsp[-3].id), (yyvsp[-1].id));
		entry = new_entry(NULL, (yyvsp[-3].id), AA_LINK_BITS, (yyvsp[-1].id));
		entry->subset = (yyvsp[-4].boolean);
		PDEBUG("rule.entry: link (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	}
#line 2581 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1010 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cod_entry *entry;
		entry = new_entry(NULL, (yyvsp[-1].id), AA_USER_PTRACE | AA_OTHER_PTRACE, NULL);
		if (!entry)
			yyerror(_("Memory allocation error."));
		(yyval.user_entry) = entry;
	}
#line 2593 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1019 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cod_entry *entry;
		entry = new_entry((yyvsp[-3].id), (yyvsp[-1].id), AA_USER_PTRACE | AA_OTHER_PTRACE, NULL);
		if (!entry)
			yyerror(_("Memory allocation error."));
		(yyval.user_entry) = entry;
	}
#line 2605 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1028 "parser_yacc.y" /* yacc.c:1646  */
    {
		size_t family;
		struct aa_network_entry *new_entry, *entry = NULL;
		for (family = AF_UNSPEC; family < get_af_max(); family++) {
			new_entry = new_network_ent(family, 0xffffffff,
						    0xffffffff);
			if (!new_entry)
				yyerror(_("Memory allocation error."));
			new_entry->next = entry;
			entry = new_entry;
		}
		(yyval.network_entry) = entry;
	}
#line 2623 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1043 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct aa_network_entry *entry;
		entry = network_entry((yyvsp[-1].id), NULL, NULL);
		if (!entry)
			/* test for short circuiting of family */
			entry = network_entry(NULL, (yyvsp[-1].id), NULL);
		if (!entry)
			yyerror(_("Invalid network entry."));
		free((yyvsp[-1].id));
		(yyval.network_entry) = entry;
	}
#line 2639 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1056 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct aa_network_entry *entry;
		entry = network_entry((yyvsp[-2].id), (yyvsp[-1].id), NULL);
		if (!entry)
			yyerror(_("Invalid network entry."));
		free((yyvsp[-2].id));
		free((yyvsp[-1].id));
		(yyval.network_entry) = entry;
	}
#line 2653 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1067 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cond_entry *ent;
		struct value_list *value = new_value_list((yyvsp[0].var_val));
		if (!value)
			yyerror(_("Memory allocation error."));
		ent = new_cond_entry((yyvsp[-2].id), 1, value);
		if (!ent) {
			free_value_list(value);
			yyerror(_("Memory allocation error."));
		}
		(yyval.cond_entry) = ent;
	}
#line 2670 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1081 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cond_entry *ent = new_cond_entry((yyvsp[-4].id), 1, (yyvsp[-1].val_list));

		if (!ent)
			yyerror(_("Memory allocation error."));
		(yyval.cond_entry) = ent;
	}
#line 2682 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1091 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cond_entry *ent = new_cond_entry((yyvsp[-4].id), 0, (yyvsp[-1].val_list));

		if (!ent)
			yyerror(_("Memory allocation error."));
		(yyval.cond_entry) = ent;
	}
#line 2694 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1099 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.cond_entry) = NULL; }
#line 2700 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1101 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyvsp[0].cond_entry)->next = (yyvsp[-1].cond_entry);
		(yyval.cond_entry) = (yyvsp[0].cond_entry);
	}
#line 2709 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1107 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-2].cond_entry), (yyvsp[-1].id), NULL, NULL, AA_MAY_MOUNT);
	}
#line 2717 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1112 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-5].cond_entry), (yyvsp[-4].id), (yyvsp[-2].cond_entry), (yyvsp[-1].id), AA_MAY_MOUNT);
	}
#line 2725 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1117 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-2].cond_entry), NULL, NULL, (yyvsp[-1].id), AA_DUMMY_REMOUNT);
	}
#line 2733 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1122 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-2].cond_entry), NULL, NULL, (yyvsp[-1].id), AA_MAY_UMOUNT);
	}
#line 2741 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1127 "parser_yacc.y" /* yacc.c:1646  */
    {
		char *name = NULL;
		if ((yyvsp[-1].transition).present && (yyvsp[-1].transition).namespace) {
			name = malloc(strlen((yyvsp[-1].transition).namespace) +
				      strlen((yyvsp[-1].transition).name) + 3);
			if (!name) {
				PERROR("Memory allocation error\n");
				exit(1);
			}
			sprintf(name, ":%s:%s", (yyvsp[-1].transition).namespace, (yyvsp[-1].transition).name);
			free((yyvsp[-1].transition).namespace);
			free((yyvsp[-1].transition).name);
		} else if ((yyvsp[-1].transition).present)
			name = (yyvsp[-1].transition).name;

		(yyval.mnt_entry) = do_pivot_rule((yyvsp[-3].cond_entry), (yyvsp[-2].id), name);
	}
#line 2763 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1145 "parser_yacc.y" /* yacc.c:1646  */
    {}
#line 2769 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1146 "parser_yacc.y" /* yacc.c:1646  */
    {}
#line 2775 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1149 "parser_yacc.y" /* yacc.c:1646  */
    {
		/* A single TOK_MODE maps to the same permission in all
		 * of user::other */
		(yyval.fmode) = parse_mode((yyvsp[0].mode));
		free((yyvsp[0].mode));
	}
#line 2786 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1157 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cod_entry *entry;
		PDEBUG("Matched change_profile: tok_id (%s)\n", (yyvsp[-1].id));
		entry = new_entry(NULL, (yyvsp[-1].id), AA_CHANGE_PROFILE, NULL);
		if (!entry)
			yyerror(_("Memory allocation error."));
		PDEBUG("change_profile.entry: (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	}
#line 2800 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1168 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cod_entry *entry;
		PDEBUG("Matched change_profile: tok_id (%s:%s)\n", (yyvsp[-3].id), (yyvsp[-1].id));
		entry = new_entry((yyvsp[-3].id), (yyvsp[-1].id), AA_CHANGE_PROFILE, NULL);
		if (!entry)
			yyerror(_("Memory allocation error."));
		PDEBUG("change_profile.entry: (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	}
#line 2814 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1180 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].cap) == 0) {
			/* bare capability keyword - set all caps */
			(yyval.cap) = 0xffffffffffffffff;
		} else
			(yyval.cap) = (yyvsp[-1].cap);
	}
#line 2826 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1188 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.cap) = 0; }
#line 2832 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1190 "parser_yacc.y" /* yacc.c:1646  */
    {
		int cap = name_to_capability((yyvsp[0].id));
		if (cap == -1)
			yyerror(_("Invalid capability %s."), (yyvsp[0].id));
		free((yyvsp[0].id));
		(yyval.cap) = (yyvsp[-1].cap) | CAP_TO_MASK(cap);
	}
#line 2844 "parser_yacc.c" /* yacc.c:1646  */
    break;


#line 2848 "parser_yacc.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1198 "parser_yacc.y" /* yacc.c:1906  */

#define MAXBUFSIZE 4096

void vprintyyerror(const char *msg, va_list argptr)
{
	char buf[MAXBUFSIZE];

	vsnprintf(buf, sizeof(buf), msg, argptr);

	if (profilename) {
		PERROR(_("AppArmor parser error for %s%s%s at line %d: %s\n"),
		       profilename,
		       current_filename ? " in " : "",
		       current_filename ? current_filename : "",
		       current_lineno, buf);
	} else {
		PERROR(_("AppArmor parser error,%s%s line %d: %s\n"),
		       current_filename ? " in " : "",
		       current_filename ? current_filename : "",
		       current_lineno, buf);
	}
}

void printyyerror(const char *msg, ...)
{
	va_list arg;

	va_start(arg, msg);
	vprintyyerror(msg, arg);
	va_end(arg);
}

void yyerror(const char *msg, ...)
{
	va_list arg;

	va_start(arg, msg);
	vprintyyerror(msg, arg);
	va_end(arg);

	exit(1);
}

struct cod_entry *do_file_rule(char *namespace, char *id, int mode,
			       char *link_id, char *nt)
{
		struct cod_entry *entry;
		PDEBUG("Matched: tok_id (%s) tok_mode (0x%x)\n", id, mode);
		entry = new_entry(namespace, id, mode, link_id);
		if (!entry)
			yyerror(_("Memory allocation error."));
		entry->nt_name = nt;
		PDEBUG("rule.entry: (%s)\n", entry->name);
		return entry;
}

/* Note: NOT currently in use, used for 
 * /foo x -> { /bah, }   style transitions
 */
void add_local_entry(struct codomain *cod)
{
	/* ugh this has to be called after the hat is attached to its parent */
	if (cod->local_mode) {
		struct cod_entry *entry;
		char *trans = malloc(strlen(cod->parent->name) +
				    strlen(cod->name) + 3);
		char *name = strdup(cod->name);
		if (!trans)
			yyerror(_("Memory allocation error."));
		sprintf(name, "%s//%s", cod->parent->name, cod->name);

		entry = new_entry(NULL, name, cod->local_mode, NULL);
		entry->audit = cod->local_audit;
		entry->nt_name = trans;
		if (!entry)
			yyerror(_("Memory allocation error."));

		add_entry_to_policy(cod, entry);
	}
}

static char *mnt_cond_msg[] = {"",
			 " not allowed as source conditional",
			 " not allowed as target conditional",
			 "",
			 NULL};

int verify_mnt_conds(struct cond_entry *conds, int src)
{
	struct cond_entry *entry;
	int error = 0;

	if (!conds)
		return 0;

	list_for_each(conds, entry) {
		int res = is_valid_mnt_cond(entry->name, src);
		if (res <= 0) {
				printyyerror(_("invalid mount conditional %s%s"),
					     entry->name,
					     res == -1 ? "" : mnt_cond_msg[src]);
				error++;
		}
	}

	return error;
}

struct mnt_entry *do_mnt_rule(struct cond_entry *src_conds, char *src,
			      struct cond_entry *dst_conds, char *dst,
			      int mode)
{
	struct mnt_entry *ent;

	if (verify_mnt_conds(src_conds, MNT_SRC_OPT) != 0)
		yyerror(_("bad mount rule"));

	/* FIXME: atm conditions are not supported on dst
	if (verify_conds(dst_conds, DST_OPT) != 0)
		yyerror(_("bad mount rule"));
	*/
	if (dst_conds)
		yyerror(_("mount point conditions not currently supported"));

	ent = new_mnt_entry(src_conds, src, dst_conds, dst, mode);
	if (!ent) {
		yyerror(_("Memory allocation error."));
	}

	return ent;
}

struct mnt_entry *do_pivot_rule(struct cond_entry *old, char *root,
				char *transition)
{
	struct mnt_entry *ent = NULL;
	char *device = NULL;
	if (old) {
		if (strcmp(old->name, "oldroot") != 0)
			yyerror(_("invalid pivotroot conditional '%s'"), old->name);
		if (old->vals) {
			device = old->vals->value;
			old->vals->value = NULL;
		}
		free_cond_entry(old);
	}

	ent = new_mnt_entry(NULL, device, NULL, root,
			    AA_MAY_PIVOTROOT);
	ent->trans = transition;

	return ent;
}
